﻿using System;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;

namespace FlexGridFilterMVVM
{
    public class MainViewModel : INotifyPropertyChanged
    {
        public ObservableCollection<Product> Products { get; private set; }

        private string _myFilterDefinition;
        public string MyFilterDefinition
        {
            get
            {
                return _myFilterDefinition;
            }
            set
            {
                _myFilterDefinition = value;
                OnPropertyChanged("MyFilterDefinition");
            }
        }

        public ICommand FilterProductsCommand { get; set; }

        public MainViewModel()
        {
            Products = new ObservableCollection<Product>();
            Products.Add(new Product { Name = "Hat", Price = 54.60 });
            Products.Add(new Product { Name = "Coat", Price = 112.95 });
            Products.Add(new Product { Name = "Gloves", Price = 19.99 });
            Products.Add(new Product { Name = "Boots", Price = 86.45 });

            FilterProductsCommand = new DelegateCommand(FilterProducts, CanFilterProducts);
        }

        private void FilterProducts(object param)
        {
            MyFilterDefinition = "<ColumnFilters><ColumnFilter ColumnName=\"Price\" BoundPropertyName=\"Price\"><ConditionFilter AndConditions=\"True\"><Condition1 op=\"IsLessThan\" val=\"100\" /></ConditionFilter></ColumnFilter></ColumnFilters>";
            
        }

        private bool CanFilterProducts(object param)
        {
            return true;
        }


        public event PropertyChangedEventHandler PropertyChanged;

        protected virtual void OnPropertyChanged(string propertyName)
        {
            if (PropertyChanged != null)
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
        }
    }

    public class Product : INotifyPropertyChanged
    {
        private string _name;
        public string Name
        {
            get
            {
                return _name;
            }
            set
            {
                _name = value;
                OnPropertyChanged("Name");
            }
        }

        private double _price;
        public double Price
        {
            get
            {
                return _price;
            }
            set
            {
                _price = value;
                OnPropertyChanged("Price");
            }
        }

        public event PropertyChangedEventHandler PropertyChanged;

        protected virtual void OnPropertyChanged(string propertyName)
        {
            if (PropertyChanged != null)
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
        }
    }
}
