﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using C1.Silverlight.FlexGrid;

namespace FlexGridFilterMVVM
{
    public partial class MyUserControl : UserControl
    {
        public MyUserControl()
        {
            InitializeComponent();

        }

        private void btnFilter_Click(object sender, RoutedEventArgs e)
        {
            //var filter = C1FlexGridFilterService.GetFlexGridFilter(c1FlexGrid1);
            //// get filter for the first column
            //var columnFilter = filter.GetColumnFilter(c1FlexGrid1.Columns["Price"]);

            //// create filter condition (Contains ‘Z’)
            //var condition = columnFilter.ConditionFilter.Condition1;
            //condition.Operator = ConditionOperator.IsLessThan;
            //condition.Parameter = 100;

        }

        private void C1FlexGridFilter_FilterApplied(object sender, EventArgs e)
        {
            if (c1FlexGrid1 != null)
            {
                var filter = C1FlexGridFilterService.GetFlexGridFilter(c1FlexGrid1);
                this.FilterDefinition = filter.FilterDefinition;
            }
        }

        #region FilterDefintion
        private static string DefaultFilterDefinition = "";

        /// <summary>
        /// FilterDefinition Dependency Property
        /// </summary>
        public static readonly DependencyProperty FilterDefinitionProperty =
            DependencyProperty.Register(
                "FilterDefinition",
                typeof(string),
                typeof(MyUserControl),
                new PropertyMetadata(DefaultFilterDefinition, OnFilterDefinitionChanged));

        /// <summary>
        /// Gets or sets the FilterDefinition property. This dependency property
        /// indicates ....
        /// </summary>
        public string FilterDefinition
        {
            get { return (string)GetValue(FilterDefinitionProperty); }
            set { SetValue(FilterDefinitionProperty, value); }
        }

        /// <summary>
        /// Handles changes to the FilterDefinition property.
        /// </summary>
        /// <param name="d">
        /// The <see cref="DependencyObject"/> on which
        /// the property has changed value.
        /// </param>
        /// <param name="e">
        /// Event data that is issued by any event that
        /// tracks changes to the effective value of this property.
        /// </param>
        private static void OnFilterDefinitionChanged(
            DependencyObject d, DependencyPropertyChangedEventArgs e)
        {
            var target = (MyUserControl)d;
            string oldFilterDefinition = (string)e.OldValue;
            string newFilterDefinition = target.FilterDefinition;
            target.OnFilterDefinitionChanged(oldFilterDefinition, newFilterDefinition);
        }

        /// <summary>
        /// Provides derived classes an opportunity to handle changes
        /// to the FilterDefinition property.
        /// </summary>
        /// <param name="oldFilterDefinition">The old FilterDefinition value</param>
        /// <param name="newFilterDefinition">The new FilterDefinition value</param>
        protected virtual void OnFilterDefinitionChanged(
            string oldFilterDefinition, string newFilterDefinition)
        {
            var filter = C1FlexGridFilterService.GetFlexGridFilter(c1FlexGrid1);
            filter.FilterDefinition = newFilterDefinition;

            // apply the filter 
            filter.Apply();
        }

        
        #endregion

        
    }
}
